<?php

use Database\Factories\PostFactory;
use Illuminate\Database\Seeder;

use App\Support\Traits\Helpers;
use App\Repositories\Models\AdminUsers;

class AdminUsersSeeder extends Seeder
{
    use Helpers;

    protected $userList = [
        [
            'username' =>'admin',
            'nickname' =>'admin',
            'password' => 'admin123456',
            'email' => 'admin@admin.com',
            'token' => '',
            'status' => 1,
            'is_admin' => 1,
            'lastlogin' => 0,
            'created_at' => '',
            'updated_at' => ''
        ]
    ];

    public function run()
    {
        collect($this->userList)->map(function($user){

            $admin = app(AdminUsers::class);
            $user['password'] = $admin->encryptPassword($user['password']);
            $user['token'] = $this->randomFromDevice(16);
            $user['created_at'] = date('Y-m-d H:i:s',time());
            $user['updated_at'] = date('Y-m-d H:i:s',time());

            AdminUsers::insert([$user]);

       });

    }
}
