<?php

use Illuminate\Database\Seeder;

use App\Repositories\Models\Menus;

class MenusSeeder extends Seeder
{

    protected $menuList = [
        [
            'menu_name' => 'page_index',
            'title' => '平台首页',
            'menu_path' => '#',
            'parent_id' => -1,
            'menu_type' => 'top',
            'menu_icon' => 'md-home',
            'component' => '',
            'status' => 1,
            'is_show' => 1,
            'sys_default' => 1,
            'sort' => 1.0,
            'created_by' => 0,
            'created_at' => '',
            'updated_at' => ''
        ],

        [
            'menu_name' => 'sys_manager',
            'title' => '系统管理',
            'menu_path' => '#',
            'parent_id' => 0,
            'menu_type' => 'page',
            'menu_icon' => 'ios-settings',
            'component' => 'Main',
            'status' => 1,
            'is_show' => 1,
            'sys_default' => 1,
            'sort' => 1.0,
            'created_by' => 0,
            'created_at' => '',
            'updated_at' => ''
        ],
    ];

    protected $subMenusList = [
        [
            'menu_name' => 'menu_permission',
            'title' => '菜单权限管理',
            'menu_path' => '/menus',
            'parent_id' => 0,
            'menu_type' => 'page',
            'menu_icon' => 'md-menu',
            'component' => 'sys/menu-manage/menuManage',
            'status' => 1,
            'is_show' => 1,
            'sys_default' => 1,
            'sort' => 1.10,
            'created_by' => 0,
            'created_at' => '',
            'updated_at' => ''
        ],
        [
            'menu_name' => 'role_permission',
            'title' => '用户权限管理',
            'menu_path' => '/permission',
            'parent_id' => 0,
            'menu_type' => 'page',
            'menu_icon' => 'md-contacts',
            'component' => 'sys/role-manage/roleManage',
            'status' => 1,
            'is_show' => 1,
            'sys_default' => 1,
            'sort' => 1.11,
            'created_by' => 0,
            'created_at' => '',
            'updated_at' => ''
        ],
        [
            'menu_name' => 'user_manage',
            'title' => '用户管理',
            'menu_path' => '/user-manage',
            'parent_id' => 0,
            'menu_type' => 'page',
            'menu_icon' => 'md-person',
            'component' => 'sys/user-manage/userManage',
            'status' => 1,
            'is_show' => 1,
            'sys_default' => 1,
            'sort' => 1.11,
            'created_by' => 0,
            'created_at' => '',
            'updated_at' => ''
        ],
    ];


    public function run()
    {
        collect($this->menuList)->map(function($menu){
            $menu['created_at'] = date('Y-m-d H:i:s',time());
            $menu['updated_at'] = date('Y-m-d H:i:s',time());

            $id = Menus::query()->insertGetId($menu);
            if($id && $menu['parent_id'] == 0){
                //初始化系统子菜单
                collect($this->subMenusList)->map(function($subMenus) use ($id){
                    $subMenus['parent_id'] = $id;
                    $subMenus['created_at'] = date('Y-m-d H:i:s',time());
                    $subMenus['updated_at'] = date('Y-m-d H:i:s',time());

                    Menus::query()->insertGetId($subMenus);
                });
            }
        });
        $topMenus = Menus::where('parent_id','=', -1)->first()->toArray();
        $pageMenus = Menus::where(['parent_id' => 0, 'menu_type' => 'page'])->first();

        $newPageMenus = $pageMenus->toArray();
        $newPageMenus['parent_id'] = $topMenus['id'];

        $pageMenus->update($newPageMenus);

    }
}
